/*****************************************************************************/
/*									     */
/*									     */
/*	X patience version 2 -- module r_Seahaven.c			     */
/*									     */
/*	Characteristics of the ``Seahaven Towers'' rules		     */
/*	written by Michael Bischoff					     */
/*	see COPYRIGHT.xpat2 for Copyright details			     */
/*									     */
/*									     */
/*****************************************************************************/
#include "xpatgame.h"


struct rules Seahaven_rules = {	/* Seahaven */
    "Seahaven",	/* shortname */
    "Seahaven Towers",	/* longname */
    "st",       /* abbrev */
    1,		/* layout_hints */
    NODEAL,	/* variant */
    CUSTOM_STD,	/* customizable */
    0,		/* customized */
    52,		/* numcards */
    4,		/* numstacks */
    10,		/* numslots */
    4,		/* numtmps */
    1,		/* numdecks */
    13,		/* cards_per_color */
    0,		/* numjokers */
    {0, 0, 0, 0},/* param[0], param[1], param[2], param[3] */
    0,		/* facedown */
    5,		/* faceup */
    0,		/* newgame_bits */
    NULL,	/* new_game */
    NULL,	/* game_won */
    NULL,	/* new_cards */
    ES_KINGS|US_RS|MG_RS|DC_ALWAYS|ST_ONE|STACK_SOURCE, /* move_bits */
    NULL,	/* deal_cards */
    NULL,	/* undeal_cards */
    NULL,	/* stackable */
    NULL,	/* movevalid */
    NULL,	/* valid */
    NULL,	/* relaxed_valid */
    std_good_hint,/* good_hint */
    NULL,	/* automove */
    NULL,	/* score */
    0,		/* maxscore */
    {0, 0, 0, 0}, /* paramstring blocks */
    0,		/* used */
    NULL,	/* initfunc */
    NULL,	/* local keyboard bindings */
};
